<#-- 按类型绘制 -->
<#macro renderByDetailType panelDetail view>
    <#if panelDetail.getItemType()?? && panelDetail.getItemType() == "CONTAINER">
    <#-- 边缘布局 -->
    <#if panelDetail.getPSLayout().getLayout()?? && panelDetail.getPSLayout().getLayout() == "BORDER" >
    <app-scroll-container name="${panelDetail.getName()}" :layoutModelDetails="layoutModelDetails">
    <#if panelDetail.getPSPanelItems()??>
        <#list panelDetail.getPSPanelItems() as panelItem>
        <template #${panelItem.getName()}>
        <@renderByDetailType panelItem view />
        </template>
        </#list>
    </#if>
    </app-scroll-container>
    <#-- SIMPLEFLEX布局(栅格布局) -->
    <#elseif panelDetail.getPSLayout().getLayout()?? && panelDetail.getPSLayout().getLayout() == "SIMPLEFLEX" >
    <app-simpleflex-container name="${panelDetail.getName()}" :layoutModelDetails="layoutModelDetails">
     <#if panelDetail.getPSPanelItems()??>
        <#list panelDetail.getPSPanelItems() as panelItem>
        <template #${panelItem.getName()}>
        <@renderByDetailType panelItem view />
        </template>
        </#list>
    </#if>
    </app-simpleflex-container>
    <#else>
    <app-standard-container name="${panelDetail.getName()}" :layoutModelDetails="layoutModelDetails">
     <#if panelDetail.getPSPanelItems()??>
        <#list panelDetail.getPSPanelItems() as panelItem>
        <template #${panelItem.getName()}>
        <@renderByDetailType panelItem view />
        </template>
        </#list>
    </#if>
    </app-standard-container>
    </#if>
    <#elseif panelDetail.getItemType()?? && panelDetail.getItemType() == "TABPAGE">
    <app-tab-page name="${panelDetail.getName()}" :layoutModelDetails="layoutModelDetails">
        <#if panelDetail.getPSPanelItems?? && panelDetail.getPSPanelItems()??>
            <#list panelDetail.getPSPanelItems() as panelItem>
        <template #${panelItem.getName()}>
            <@renderByDetailType panelItem view />
        </template>
            </#list>
        </#if>
    </app-tab-page>
    <#elseif panelDetail.getItemType()?? && panelDetail.getItemType() == "TABPANEL">
    <app-tab-panel name="${panelDetail.getName()}" :layoutModelDetails="layoutModelDetails">
        <#if panelDetail.getPSPanelTabPages?? && panelDetail.getPSPanelTabPages()??>
            <#list panelDetail.getPSPanelTabPages() as tabPage>
        <template #${tabPage.getName()}>
            <@renderByDetailType tabPage view />
        </template>
            </#list>
        </#if>
    </app-tab-panel>
    <#elseif panelDetail.getItemType()?? && panelDetail.getItemType() == "FIELD">
        <#if panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "AUTH_USERID">
        <app-login-input v-model="formData.loginName" icon="ios-contact" :placeholder="$t('components.login.placeholder1')" />
        <#elseif panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "AUTH_PASSWORD">
        <app-login-input v-model="formData.password" icon="ios-key" :placeholder="$t('components.login.placeholder2')" />
        <#elseif panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "AUTH_ORGPICK">
        <app-login-org />
        <#elseif panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "AUTH_VERIFICATIONCODE">
        <app-login-note-verify />
        <#elseif panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "AUTH_LOGINMSG">
        <app-login-message />
        <#elseif panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "APP_APPTITLE">
        <app-preset-title />
        <#elseif panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "VIEW_PAGECAPTION">
        <app-preset-caption>${view.caption}</app-preset-caption>
        <#elseif panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "FIELD_TEXT_DYNAMIC">
        <app-preset-text name="${panelDetail.getName()}" predefinedType="${panelDetail.getPSEditor().getPredefinedType()}"/>
        <#else>
        <span>属性项</span>
        </#if>
    <#elseif panelDetail.getItemType()?? && panelDetail.getItemType() == "RAWITEM">
        <#if panelDetail.getPSRawItem?? && panelDetail.getPSRawItem()??>
        <#assign rawdetail = panelDetail.getPSRawItem()/>      
        <#if  rawdetail.getPredefinedType?? && rawdetail.getPredefinedType()?? && rawdetail.getPredefinedType() == 'STATIC_IMAGE'>
        <app-rawitem-image
            type="STATIC_IMAGE"
            <#if rawdetail.getCssStyle?? && rawdetail.getCssStyle()??>
            cssStyle="${ rawdetail.getCssStyle() }"
            </#if>
            <#if rawdetail.getPSSysImage?? && rawdetail.getPSSysImage()?? && rawdetail.getPSSysImage().getImagePath?? && rawdetail.getPSSysImage().getImagePath()??>
            imgurl="${ rawdetail.getPSSysImage().getImagePath() }"
            </#if>
            <#if rawdetail.getPSSysImage?? && rawdetail.getPSSysImage()?? && rawdetail.getPSSysImage().getCssClass?? && rawdetail.getPSSysImage().getCssClass()??>
            imageClass="${ rawdetail.getPSSysImage().getCssClass() }"
            </#if>>
            </app-rawitem-image>
        <#elseif rawdetail.getPredefinedType?? && rawdetail.getPredefinedType()?? && rawdetail.getPredefinedType() == 'STATIC_CAROUSEL'>
        <app-rawitem-carousel>
        </app-rawitem-carousel>
        <#elseif rawdetail.getPredefinedType?? && rawdetail.getPredefinedType()?? && rawdetail.getPredefinedType() == 'STATIC_VIDEOPLAYER'>
        <span>这里放视频</span>
        <#elseif panelDetail.getPSRawItem?? && panelDetail.getPSRawItem()?? && panelDetail.getPSRawItem().getPredefinedType?? && panelDetail.getPSRawItem().getPredefinedType()?? && panelDetail.getPSRawItem().getPredefinedType() == 'NAV_POS'>
            <app-nav-pos name="${panelDetail.getName()}" :layoutModelDetails="layoutModelDetails" :navData="layoutModelDetails['${panelDetail.getName()}'].navData"></app-nav-pos>
        <#elseif panelDetail.getPSRawItem?? && panelDetail.getPSRawItem()?? && panelDetail.getPSRawItem().getPredefinedType?? && panelDetail.getPSRawItem().getPredefinedType()?? && (panelDetail.getPSRawItem().getPredefinedType() == 'STATIC_LABEL' || panelDetail.getPSRawItem().getPredefinedType() == 'STATIC_TEXT')>
        <app-preset-text 
            name="${panelDetail.getName()}"
            predefinedType="${panelDetail.getPSRawItem().getPredefinedType()}" 
            renderMode="${panelDetail.getPSRawItem().getRenderMode()}"
            contentType="${panelDetail.getPSRawItem().getContentType()}" 
            <#if panelDetail.getPSRawItem().getContentType() == 'RAW'>
            value="${panelDetail.getRawContent()}"
            <#elseif panelDetail.getPSRawItem().getContentType() == 'HTML'>
            value="${panelDetail.getHtmlContent()}"
            </#if>
            contentStyle="${panelDetail.getPSRawItem().getCssStyle()}"/>
        <#elseif panelDetail.getPSRawItem?? && panelDetail.getPSRawItem()?? && panelDetail.getPSRawItem().getPredefinedType?? && panelDetail.getPSRawItem().getPredefinedType()?? && panelDetail.getPSRawItem().getPredefinedType() == 'NAV_TABS'>
            <tab-page-exp></tab-page-exp>
        </#if>
     </#if>
    <#elseif panelDetail.getItemType()?? && panelDetail.getItemType() == "BUTTON">
        <#if panelDetail.getPSUIAction?? && panelDetail.getPSUIAction()?? && panelDetail.getPSUIAction().getPredefinedType?? && panelDetail.getPSUIAction().getPredefinedType()?? && panelDetail.getPSUIAction().getPredefinedType() == "APP_LOGIN">
        <app-login-button class="app-login" :model="layoutModelDetails.${panelDetail.getName()}" type='primary' :model="layoutModelDetails." :caption="$t('components.login.name')" @itemClick="handleItemClick" />
        <#elseif panelDetail.getPSUIAction?? && panelDetail.getPSUIAction()?? && panelDetail.getPSUIAction().getPredefinedType?? && panelDetail.getPSUIAction().getPredefinedType()?? && panelDetail.getPSUIAction().getPredefinedType() == "APP_REGISTER">
        <app-login-button class="app-register" :model="layoutModelDetails.${panelDetail.getName()}" type='success' :model="layoutModelDetails." :caption="$t('components.login.register')" @itemClick="handleItemClick" />
        <#elseif panelDetail.getPSUIAction?? && panelDetail.getPSUIAction()?? && panelDetail.getPSUIAction().getPredefinedType?? && panelDetail.getPSUIAction().getPredefinedType()?? && panelDetail.getPSUIAction().getPredefinedType() == "DATA_CANCELCHANGES">
        <app-login-button class="app-reset" :model="layoutModelDetails.${panelDetail.getName()}" type='success' :model="layoutModelDetails." :caption="$t('components.login.reset')" @itemClick="handleItemClick" />
        <#elseif panelDetail.getPSUIAction?? && panelDetail.getPSUIAction()?? && panelDetail.getPSUIAction().getPredefinedType?? && panelDetail.getPSUIAction().getPredefinedType()?? && panelDetail.getPSUIAction().getPredefinedType() == "APP_LOGOUT">
        <app-login-button class="app-logout" :model="layoutModelDetails.${panelDetail.getName()}" :caption="$t('components.login.logout')" @itemClick="handleItemClick" />
        <#else>
        <span>按钮</span>
        </#if>
    <#elseif panelDetail.getItemType()?? && panelDetail.getItemType() == "CTRLPOS">
        <#if view?? && view.hasPSControl?? && view.hasPSControl(panelDetail.getName())>
            ${P.getCtrlCode(panelDetail.getName(), 'CONTROL.html').code}
        <#else>
        <span>部件占位${panelDetail.getName()}</span>
        </#if>
    <#elseif panelDetail.getItemType()?? && panelDetail.getItemType() == "USERCONTROL">
        <#if panelDetail.getPredefinedType?? && panelDetail.getPredefinedType()?? && panelDetail.getPredefinedType() == "AUTH_CAPTCHA">
        <app-login-captcha />
        <#elseif panelDetail.getPredefinedType?? && panelDetail.getPredefinedType()?? && panelDetail.getPredefinedType() == "AUTH_SSO">
        <app-login-third />
        <#else>
        <span>用户自定义控件</span>
        </#if>
    <#else>
    <span>${panelDetail.getItemType()}暂未支持</span>
    </#if>
</#macro>

